// Copyright The OpenTelemetry Authors
// SPDX-License-Identifier: Apache-2.0

// <auto-generated>This file has been auto generated from scripts/templates/SemanticConventionsAttributes.cs.j2</auto-generated>

#pragma warning disable CS1570 // XML comment has badly formed XML

using System;

namespace OpenTelemetry.SemanticConventions;

/// <summary>
/// Constants for semantic attribute names outlined by the OpenTelemetry specifications.
/// </summary>
public static class ClientAttributes
{
    /// <summary>
    /// Client address - domain name if available without reverse DNS lookup; otherwise, IP address or Unix domain socket name.
    /// </summary>
    /// <remarks>
    /// When observed from the server side, and when communicating through an intermediary, <c>client.address</c> SHOULD represent the client address behind any intermediaries,  for example proxies, if it&amp;#39;s available.
    /// </remarks>
    public const string AttributeClientAddress = "client.address";

    /// <summary>
    /// Client port number.
    /// </summary>
    /// <remarks>
    /// When observed from the server side, and when communicating through an intermediary, <c>client.port</c> SHOULD represent the client port behind any intermediaries,  for example proxies, if it&amp;#39;s available.
    /// </remarks>
    public const string AttributeClientPort = "client.port";
}
